﻿Type=Activity
Version=3.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'variable for the filter query, 
	'defined in the btnFilter_Click routine
	'and will be used In the DBWebView ShowTable routine
	Dim Query = "" As String
	
	' flag for the filter active or inactive
	Dim flagFilterActive = False As Boolean
	
	' Boolean operator used in the filter
	' can be OR or AND
	Dim BooleanOperator = "OR " As String
	
	' Variables used to hold the selected indexes of the Spinners
	Dim SelectedFirstName = 0 As Int
	Dim SelectedLastName = 0 As Int
	Dim SelectedCity = 0 As Int
End Sub

Sub Globals
	Dim spnFirstName, spnLastName, spnCity As Spinner
	Dim btnFilter, btnBooleanOperator As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Filter")
	Activity.Title = "SQLiteLight2  Filter"
	InitSpinners
End Sub

Sub Activity_Resume
	'set the text of the btnBooleanOperator button
	btnBooleanOperator.Text = BooleanOperator

	'set the last selected indexes of the Spinners
	spnFirstName.SelectedIndex = SelectedFirstName
	spnLastName.SelectedIndex = SelectedLastName
	spnCity.SelectedIndex = SelectedCity
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub btnFilter_Click
	'a query will look like something
	' WHERE FirstName = 'John'
	' WHERE FirstName = 'John' AND LastName = 'KENNEDY'
	' WHERE FirstName = 'John' AND City = 'London'
	' WHERE FirstName = 'John' AND LastName = 'KENNEDY' AND City = 'London'
	'the single quotes are needed because the values are strings
	
	Query = " WHERE "		'beginning of the query
	
	'if a FirstName is selected then spnFirstName.SelectedIndex > 0 and we add FirstName = 'selected first name'
	If spnFirstName.SelectedIndex > 0 Then
		Query = Query & "FirstName = '" & spnFirstName.SelectedItem & "' " 
	End If

	'if a LastName is selected then we add 
	' LastName = 'selected last name' if no first name was selected
	' AND LastName = 'selected last name' or OR LastName = 'selected last name' 
	'depending on the boolean operator
	If spnLastName.SelectedIndex > 0 Then
		If Query = " WHERE " Then
			Query = Query & "LastName = '" & spnLastName.SelectedItem & "' " 
		Else
			Query = Query & BooleanOperator & "LastName = '" & spnLastName.SelectedItem & "' " 
		End If
	End If

	'if a City is selected then we add 
	' City = 'selected first name' if it's the first selection
	' AND City = 'selected city' or OR City = 'selected city'
	'depending on the boolean operator
	If spnCity.SelectedIndex > 0 Then
		If Query = " WHERE " Then
			Query = Query & "City = '" & spnCity.SelectedItem & "' " 
		Else
			Query = Query & BooleanOperator & "City = '" & spnCity.SelectedItem & "' " 
		End If
	End If
	
	'if nothing was selected set Query = ""
	If Query = " WHERE " Then
		Query = ""
	End If
	
	'set the filter to active
	flagFilterActive = True
	
	'memorize the selected indexes of the Spinners
	SelectedFirstName = spnFirstName.SelectedIndex
	SelectedLastName = spnLastName.SelectedIndex
	SelectedCity = spnCity.SelectedIndex
	
	'quit the Activity, returns to the DBWebView Activity
	Activity.Finish
End Sub

Sub btnBooleanOperator_Click
	'selects the boolean operator and changes the text in the button
	If btnBooleanOperator.Text = "OR " Then
		btnBooleanOperator.Text = "AND "
		BooleanOperator = "AND "
	Else
		btnBooleanOperator.Text = "OR "
		BooleanOperator = "OR "
	End If
End Sub

'Initialize the Spinners
Sub InitSpinners
	Dim i As Int
	Dim Query1 As String
	Dim Curs As Cursor
	
	'We execute a query for each column and fill the Spinner
	'We use SELECT DISTINCT to have each existing first name in the database only once
	Query1 = "SELECT DISTINCT FirstName FROM persons"
	Curs = Main.SQL1.ExecQuery(Query1)
	'we add 'no filter' as no selection
	spnFirstName.Add("no filter")
	'we fill the Spinner with the data from the database
	For i = 0 To Curs.RowCount - 1
		Curs.Position = i
		spnFirstName.Add(Curs.GetString("FirstName"))
	Next 
	
	'same for last name
	Query1 = "SELECT DISTINCT LastName FROM persons"
	Curs = Main.SQL1.ExecQuery(Query1)
	spnLastName.Add("no filter")
	For i = 0 To Curs.RowCount - 1
		Curs.Position = i
		spnLastName.Add(Curs.GetString("LastName"))
	Next 
	
	'same for city
	Query1 = "SELECT DISTINCT City FROM persons"
	Curs = Main.SQL1.ExecQuery(Query1)
	spnCity.Add("no filter")
	For i = 0 To Curs.RowCount - 1
		Curs.Position = i
		spnCity.Add(Curs.GetString("City"))
	Next 
	Curs.Close	
End Sub
